"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file

Code generated by boomtown. DO NOT EDIT.
"""

import arista.action.v1.action_pb2
import arista.subscriptions.subscriptions_pb2
import arista.time.time_pb2
import builtins
import collections.abc
import fmp.deletes_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.timestamp_pb2
import google.protobuf.wrappers_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class MetaResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TIME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    COUNT_FIELD_NUMBER: builtins.int
    type: arista.subscriptions.subscriptions_pb2.Operation.ValueType
    """Operation indicates how the value in this response should be considered.
    Under non-subscribe requests, this value should always be INITIAL. In a subscription,
    once all initial data is streamed and the client begins to receive modification updates,
    you should not see INITIAL again.
    """
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time holds the timestamp of the last item included in the metadata calculation."""

    @property
    def count(self) -> google.protobuf.wrappers_pb2.UInt32Value:
        """Count is the number of items present under the conditions of the request."""

    def __init__(
        self,
        *,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        type: arista.subscriptions.subscriptions_pb2.Operation.ValueType = ...,
        count: google.protobuf.wrappers_pb2.UInt32Value | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["count", b"count", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["count", b"count", "time", b"time", "type", b"type"]) -> None: ...

global___MetaResponse = MetaResponse

@typing.final
class ActionRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key uniquely identifies a Action instance to retrieve.
        This value must be populated.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionRequest = ActionRequest

@typing.final
class ActionResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.Action:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time carries the (UTC) timestamp of the last-modification of the
        Action instance in this response.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.Action | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionResponse = ActionResponse

@typing.final
class ActionSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionKey]: ...
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionKey] | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys", "time", b"time"]) -> None: ...

global___ActionSomeRequest = ActionSomeRequest

@typing.final
class ActionSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.Action:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """Error is an optional field.
        It should be filled when there is an error in the GetSome process.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.Action | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> None: ...

global___ActionSomeResponse = ActionSomeResponse

@typing.final
class ActionStreamRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.Action]:
        """PartialEqFilter provides a way to server-side filter a GetAll/Subscribe.
        This requires all provided fields to be equal to the response.

        While transparent to users, this field also allows services to optimize internal
        subscriptions if filter(s) are sufficiently specific.
        """

    @property
    def time(self) -> arista.time.time_pb2.TimeBounds:
        """TimeRange allows limiting response data to within a specified time window.
        If this field is populated, at least one of the two time fields are required.

        For GetAll, the fields start and end can be used as follows:

          * end: Returns the state of each Action at end.
            * Each Action response is fully-specified (all fields set).
          * start: Returns the state of each Action at start, followed by updates until now.
            * Each Action response at start is fully-specified, but updates may be partial.
          * start and end: Returns the state of each Action at start, followed by updates
            until end.
            * Each Action response at start is fully-specified, but updates until end may
              be partial.

        This field is not allowed in the Subscribe RPC.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.Action] | None = ...,
        time: arista.time.time_pb2.TimeBounds | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter", "time", b"time"]) -> None: ...

global___ActionStreamRequest = ActionStreamRequest

@typing.final
class ActionStreamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    type: arista.subscriptions.subscriptions_pb2.Operation.ValueType
    """Operation indicates how the Action value in this response should be considered.
    Under non-subscribe requests, this value should always be INITIAL. In a subscription,
    once all initial data is streamed and the client begins to receive modification updates,
    you should not see INITIAL again.
    """
    @property
    def value(self) -> arista.action.v1.action_pb2.Action:
        """Value is a value deemed relevant to the initiating request.
        This structure will always have its key-field populated. Which other fields are
        populated, and why, depends on the value of Operation and what triggered this notification.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time holds the timestamp of this Action's last modification."""

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.Action | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        type: arista.subscriptions.subscriptions_pb2.Operation.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "type", b"type", "value", b"value"]) -> None: ...

global___ActionStreamResponse = ActionStreamResponse

@typing.final
class ActionArgConfigRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key uniquely identifies a ActionArgConfig instance to retrieve.
        This value must be populated.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionArgConfigRequest = ActionArgConfigRequest

@typing.final
class ActionArgConfigResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionArgConfig:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time carries the (UTC) timestamp of the last-modification of the
        ActionArgConfig instance in this response.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionArgConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionArgConfigResponse = ActionArgConfigResponse

@typing.final
class ActionArgConfigSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionKey]: ...
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionKey] | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys", "time", b"time"]) -> None: ...

global___ActionArgConfigSomeRequest = ActionArgConfigSomeRequest

@typing.final
class ActionArgConfigSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionArgConfig:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """Error is an optional field.
        It should be filled when there is an error in the GetSome process.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionArgConfig | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> None: ...

global___ActionArgConfigSomeResponse = ActionArgConfigSomeResponse

@typing.final
class ActionArgConfigStreamRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionArgConfig]:
        """PartialEqFilter provides a way to server-side filter a GetAll/Subscribe.
        This requires all provided fields to be equal to the response.

        While transparent to users, this field also allows services to optimize internal
        subscriptions if filter(s) are sufficiently specific.
        """

    @property
    def time(self) -> arista.time.time_pb2.TimeBounds:
        """TimeRange allows limiting response data to within a specified time window.
        If this field is populated, at least one of the two time fields are required.

        For GetAll, the fields start and end can be used as follows:

          * end: Returns the state of each ActionArgConfig at end.
            * Each ActionArgConfig response is fully-specified (all fields set).
          * start: Returns the state of each ActionArgConfig at start, followed by updates until now.
            * Each ActionArgConfig response at start is fully-specified, but updates may be partial.
          * start and end: Returns the state of each ActionArgConfig at start, followed by updates
            until end.
            * Each ActionArgConfig response at start is fully-specified, but updates until end may
              be partial.

        This field is not allowed in the Subscribe RPC.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionArgConfig] | None = ...,
        time: arista.time.time_pb2.TimeBounds | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter", "time", b"time"]) -> None: ...

global___ActionArgConfigStreamRequest = ActionArgConfigStreamRequest

@typing.final
class ActionArgConfigStreamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    type: arista.subscriptions.subscriptions_pb2.Operation.ValueType
    """Operation indicates how the ActionArgConfig value in this response should be considered.
    Under non-subscribe requests, this value should always be INITIAL. In a subscription,
    once all initial data is streamed and the client begins to receive modification updates,
    you should not see INITIAL again.
    """
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionArgConfig:
        """Value is a value deemed relevant to the initiating request.
        This structure will always have its key-field populated. Which other fields are
        populated, and why, depends on the value of Operation and what triggered this notification.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time holds the timestamp of this ActionArgConfig's last modification."""

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionArgConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        type: arista.subscriptions.subscriptions_pb2.Operation.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "type", b"type", "value", b"value"]) -> None: ...

global___ActionArgConfigStreamResponse = ActionArgConfigStreamResponse

@typing.final
class ActionArgConfigSetRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionArgConfig:
        """ActionArgConfig carries the value to set into the datastore.
        See the documentation on the ActionArgConfig struct for which fields are required.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionArgConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["value", b"value"]) -> None: ...

global___ActionArgConfigSetRequest = ActionArgConfigSetRequest

@typing.final
class ActionArgConfigSetResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionArgConfig:
        """Value carries all the values given in the ActionArgConfigSetRequest as well
        as any server-generated values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp at which the system recognizes the
        creation. The only guarantees made about this timestamp are:

           - it is after the time the request was received
           - a time-ranged query with StartTime==CreatedAt will include this instance.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionArgConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionArgConfigSetResponse = ActionArgConfigSetResponse

@typing.final
class ActionArgConfigSetSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionArgConfig]:
        """value contains a list of ActionArgConfig values to write.
        It is possible to provide more values than can fit within either:
            - the maxiumum send size of the client
            - the maximum receive size of the server
        If this error occurs you must reduce the number of values sent.
        See gRPC "maximum message size" documentation for more information.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[arista.action.v1.action_pb2.ActionArgConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___ActionArgConfigSetSomeRequest = ActionArgConfigSetSomeRequest

@typing.final
class ActionArgConfigSetSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey: ...
    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key"]) -> None: ...

global___ActionArgConfigSetSomeResponse = ActionArgConfigSetSomeResponse

@typing.final
class ActionArgConfigDeleteRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key indicates which ActionArgConfig instance to remove.
        This field must always be set.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key"]) -> None: ...

global___ActionArgConfigDeleteRequest = ActionArgConfigDeleteRequest

@typing.final
class ActionArgConfigDeleteResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key echoes back the key of the deleted ActionArgConfig instance."""

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp at which the system recognizes the
        deletion. The only guarantees made about this timestamp are:

           - it is after the time the request was received
           - a time-ranged query with StartTime==DeletedAt will not include this instance.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionArgConfigDeleteResponse = ActionArgConfigDeleteResponse

@typing.final
class ActionArgConfigDeleteSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionKey]:
        """key contains a list of ActionArgConfig keys to delete"""

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionKey] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys"]) -> None: ...

global___ActionArgConfigDeleteSomeRequest = ActionArgConfigDeleteSomeRequest

@typing.final
class ActionArgConfigDeleteSomeResponse(google.protobuf.message.Message):
    """ActionArgConfigDeleteSomeResponse is only sent when there is an error."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey: ...
    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key"]) -> None: ...

global___ActionArgConfigDeleteSomeResponse = ActionArgConfigDeleteSomeResponse

@typing.final
class ActionArgConfigDeleteAllRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionArgConfig]:
        """PartialEqFilter provides a way to server-side filter a DeleteAll.
        This requires all provided fields to be equal to the response.
        A filtered DeleteAll will use GetAll with filter to find things to delete.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionArgConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter"]) -> None: ...

global___ActionArgConfigDeleteAllRequest = ActionArgConfigDeleteAllRequest

@typing.final
class ActionArgConfigDeleteAllResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    type: fmp.deletes_pb2.DeleteError.ValueType
    """This describes the class of delete error.
    A DeleteAllResponse is only sent when there is an error.
    """
    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """This indicates the error message from the delete failure."""

    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """This is the key of the ActionArgConfig instance that failed to be deleted."""

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp when the key was being deleted."""

    def __init__(
        self,
        *,
        type: fmp.deletes_pb2.DeleteError.ValueType = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key", "time", b"time", "type", b"type"]) -> None: ...

global___ActionArgConfigDeleteAllResponse = ActionArgConfigDeleteAllResponse

@typing.final
class ActionConfigRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key uniquely identifies a ActionConfig instance to retrieve.
        This value must be populated.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionConfigRequest = ActionConfigRequest

@typing.final
class ActionConfigResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionConfig:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time carries the (UTC) timestamp of the last-modification of the
        ActionConfig instance in this response.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionConfigResponse = ActionConfigResponse

@typing.final
class ActionConfigSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionKey]: ...
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionKey] | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys", "time", b"time"]) -> None: ...

global___ActionConfigSomeRequest = ActionConfigSomeRequest

@typing.final
class ActionConfigSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionConfig:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """Error is an optional field.
        It should be filled when there is an error in the GetSome process.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionConfig | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> None: ...

global___ActionConfigSomeResponse = ActionConfigSomeResponse

@typing.final
class ActionConfigStreamRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionConfig]:
        """PartialEqFilter provides a way to server-side filter a GetAll/Subscribe.
        This requires all provided fields to be equal to the response.

        While transparent to users, this field also allows services to optimize internal
        subscriptions if filter(s) are sufficiently specific.
        """

    @property
    def time(self) -> arista.time.time_pb2.TimeBounds:
        """TimeRange allows limiting response data to within a specified time window.
        If this field is populated, at least one of the two time fields are required.

        For GetAll, the fields start and end can be used as follows:

          * end: Returns the state of each ActionConfig at end.
            * Each ActionConfig response is fully-specified (all fields set).
          * start: Returns the state of each ActionConfig at start, followed by updates until now.
            * Each ActionConfig response at start is fully-specified, but updates may be partial.
          * start and end: Returns the state of each ActionConfig at start, followed by updates
            until end.
            * Each ActionConfig response at start is fully-specified, but updates until end may
              be partial.

        This field is not allowed in the Subscribe RPC.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionConfig] | None = ...,
        time: arista.time.time_pb2.TimeBounds | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter", "time", b"time"]) -> None: ...

global___ActionConfigStreamRequest = ActionConfigStreamRequest

@typing.final
class ActionConfigStreamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    type: arista.subscriptions.subscriptions_pb2.Operation.ValueType
    """Operation indicates how the ActionConfig value in this response should be considered.
    Under non-subscribe requests, this value should always be INITIAL. In a subscription,
    once all initial data is streamed and the client begins to receive modification updates,
    you should not see INITIAL again.
    """
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionConfig:
        """Value is a value deemed relevant to the initiating request.
        This structure will always have its key-field populated. Which other fields are
        populated, and why, depends on the value of Operation and what triggered this notification.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time holds the timestamp of this ActionConfig's last modification."""

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        type: arista.subscriptions.subscriptions_pb2.Operation.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "type", b"type", "value", b"value"]) -> None: ...

global___ActionConfigStreamResponse = ActionConfigStreamResponse

@typing.final
class ActionConfigSetRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionConfig:
        """ActionConfig carries the value to set into the datastore.
        See the documentation on the ActionConfig struct for which fields are required.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["value", b"value"]) -> None: ...

global___ActionConfigSetRequest = ActionConfigSetRequest

@typing.final
class ActionConfigSetResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionConfig:
        """Value carries all the values given in the ActionConfigSetRequest as well
        as any server-generated values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp at which the system recognizes the
        creation. The only guarantees made about this timestamp are:

           - it is after the time the request was received
           - a time-ranged query with StartTime==CreatedAt will include this instance.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionConfigSetResponse = ActionConfigSetResponse

@typing.final
class ActionConfigSetSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionConfig]:
        """value contains a list of ActionConfig values to write.
        It is possible to provide more values than can fit within either:
            - the maxiumum send size of the client
            - the maximum receive size of the server
        If this error occurs you must reduce the number of values sent.
        See gRPC "maximum message size" documentation for more information.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[arista.action.v1.action_pb2.ActionConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___ActionConfigSetSomeRequest = ActionConfigSetSomeRequest

@typing.final
class ActionConfigSetSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey: ...
    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key"]) -> None: ...

global___ActionConfigSetSomeResponse = ActionConfigSetSomeResponse

@typing.final
class ActionConfigDeleteRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key indicates which ActionConfig instance to remove.
        This field must always be set.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key"]) -> None: ...

global___ActionConfigDeleteRequest = ActionConfigDeleteRequest

@typing.final
class ActionConfigDeleteResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """Key echoes back the key of the deleted ActionConfig instance."""

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp at which the system recognizes the
        deletion. The only guarantees made about this timestamp are:

           - it is after the time the request was received
           - a time-ranged query with StartTime==DeletedAt will not include this instance.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionConfigDeleteResponse = ActionConfigDeleteResponse

@typing.final
class ActionConfigDeleteSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionKey]:
        """key contains a list of ActionConfig keys to delete"""

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionKey] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys"]) -> None: ...

global___ActionConfigDeleteSomeRequest = ActionConfigDeleteSomeRequest

@typing.final
class ActionConfigDeleteSomeResponse(google.protobuf.message.Message):
    """ActionConfigDeleteSomeResponse is only sent when there is an error."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey: ...
    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key"]) -> None: ...

global___ActionConfigDeleteSomeResponse = ActionConfigDeleteSomeResponse

@typing.final
class ActionConfigDeleteAllRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionConfig]:
        """PartialEqFilter provides a way to server-side filter a DeleteAll.
        This requires all provided fields to be equal to the response.
        A filtered DeleteAll will use GetAll with filter to find things to delete.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter"]) -> None: ...

global___ActionConfigDeleteAllRequest = ActionConfigDeleteAllRequest

@typing.final
class ActionConfigDeleteAllResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    type: fmp.deletes_pb2.DeleteError.ValueType
    """This describes the class of delete error.
    A DeleteAllResponse is only sent when there is an error.
    """
    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """This indicates the error message from the delete failure."""

    @property
    def key(self) -> arista.action.v1.action_pb2.ActionKey:
        """This is the key of the ActionConfig instance that failed to be deleted."""

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp when the key was being deleted."""

    def __init__(
        self,
        *,
        type: fmp.deletes_pb2.DeleteError.ValueType = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        key: arista.action.v1.action_pb2.ActionKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key", "time", b"time", "type", b"type"]) -> None: ...

global___ActionConfigDeleteAllResponse = ActionConfigDeleteAllResponse

@typing.final
class ActionRunRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey:
        """Key uniquely identifies a ActionRun instance to retrieve.
        This value must be populated.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionRunRequest = ActionRunRequest

@typing.final
class ActionRunResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRun:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time carries the (UTC) timestamp of the last-modification of the
        ActionRun instance in this response.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRun | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionRunResponse = ActionRunResponse

@typing.final
class ActionRunSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRunKey]: ...
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRunKey] | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys", "time", b"time"]) -> None: ...

global___ActionRunSomeRequest = ActionRunSomeRequest

@typing.final
class ActionRunSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRun:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """Error is an optional field.
        It should be filled when there is an error in the GetSome process.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRun | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> None: ...

global___ActionRunSomeResponse = ActionRunSomeResponse

@typing.final
class ActionRunStreamRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRun]:
        """PartialEqFilter provides a way to server-side filter a GetAll/Subscribe.
        This requires all provided fields to be equal to the response.

        While transparent to users, this field also allows services to optimize internal
        subscriptions if filter(s) are sufficiently specific.
        """

    @property
    def time(self) -> arista.time.time_pb2.TimeBounds:
        """TimeRange allows limiting response data to within a specified time window.
        If this field is populated, at least one of the two time fields are required.

        For GetAll, the fields start and end can be used as follows:

          * end: Returns the state of each ActionRun at end.
            * Each ActionRun response is fully-specified (all fields set).
          * start: Returns the state of each ActionRun at start, followed by updates until now.
            * Each ActionRun response at start is fully-specified, but updates may be partial.
          * start and end: Returns the state of each ActionRun at start, followed by updates
            until end.
            * Each ActionRun response at start is fully-specified, but updates until end may
              be partial.

        This field is not allowed in the Subscribe RPC.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRun] | None = ...,
        time: arista.time.time_pb2.TimeBounds | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter", "time", b"time"]) -> None: ...

global___ActionRunStreamRequest = ActionRunStreamRequest

@typing.final
class ActionRunStreamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    type: arista.subscriptions.subscriptions_pb2.Operation.ValueType
    """Operation indicates how the ActionRun value in this response should be considered.
    Under non-subscribe requests, this value should always be INITIAL. In a subscription,
    once all initial data is streamed and the client begins to receive modification updates,
    you should not see INITIAL again.
    """
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRun:
        """Value is a value deemed relevant to the initiating request.
        This structure will always have its key-field populated. Which other fields are
        populated, and why, depends on the value of Operation and what triggered this notification.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time holds the timestamp of this ActionRun's last modification."""

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRun | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        type: arista.subscriptions.subscriptions_pb2.Operation.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "type", b"type", "value", b"value"]) -> None: ...

global___ActionRunStreamResponse = ActionRunStreamResponse

@typing.final
class ActionRunConfigRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey:
        """Key uniquely identifies a ActionRunConfig instance to retrieve.
        This value must be populated.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionRunConfigRequest = ActionRunConfigRequest

@typing.final
class ActionRunConfigResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRunConfig:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time carries the (UTC) timestamp of the last-modification of the
        ActionRunConfig instance in this response.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRunConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionRunConfigResponse = ActionRunConfigResponse

@typing.final
class ActionRunConfigSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRunKey]: ...
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the time for which you are interested in the data.
        If no time is given, the server will use the time at which it makes the request.
        """

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRunKey] | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys", "time", b"time"]) -> None: ...

global___ActionRunConfigSomeRequest = ActionRunConfigSomeRequest

@typing.final
class ActionRunConfigSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRunConfig:
        """Value is the value requested.
        This structure will be fully-populated as it exists in the datastore. If
        optional fields were not given at creation, these fields will be empty or
        set to default values.
        """

    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """Error is an optional field.
        It should be filled when there is an error in the GetSome process.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRunConfig | None = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "time", b"time", "value", b"value"]) -> None: ...

global___ActionRunConfigSomeResponse = ActionRunConfigSomeResponse

@typing.final
class ActionRunConfigStreamRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRunConfig]:
        """PartialEqFilter provides a way to server-side filter a GetAll/Subscribe.
        This requires all provided fields to be equal to the response.

        While transparent to users, this field also allows services to optimize internal
        subscriptions if filter(s) are sufficiently specific.
        """

    @property
    def time(self) -> arista.time.time_pb2.TimeBounds:
        """TimeRange allows limiting response data to within a specified time window.
        If this field is populated, at least one of the two time fields are required.

        For GetAll, the fields start and end can be used as follows:

          * end: Returns the state of each ActionRunConfig at end.
            * Each ActionRunConfig response is fully-specified (all fields set).
          * start: Returns the state of each ActionRunConfig at start, followed by updates until now.
            * Each ActionRunConfig response at start is fully-specified, but updates may be partial.
          * start and end: Returns the state of each ActionRunConfig at start, followed by updates
            until end.
            * Each ActionRunConfig response at start is fully-specified, but updates until end may
              be partial.

        This field is not allowed in the Subscribe RPC.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRunConfig] | None = ...,
        time: arista.time.time_pb2.TimeBounds | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter", "time", b"time"]) -> None: ...

global___ActionRunConfigStreamRequest = ActionRunConfigStreamRequest

@typing.final
class ActionRunConfigStreamResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    type: arista.subscriptions.subscriptions_pb2.Operation.ValueType
    """Operation indicates how the ActionRunConfig value in this response should be considered.
    Under non-subscribe requests, this value should always be INITIAL. In a subscription,
    once all initial data is streamed and the client begins to receive modification updates,
    you should not see INITIAL again.
    """
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRunConfig:
        """Value is a value deemed relevant to the initiating request.
        This structure will always have its key-field populated. Which other fields are
        populated, and why, depends on the value of Operation and what triggered this notification.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time holds the timestamp of this ActionRunConfig's last modification."""

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRunConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        type: arista.subscriptions.subscriptions_pb2.Operation.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "type", b"type", "value", b"value"]) -> None: ...

global___ActionRunConfigStreamResponse = ActionRunConfigStreamResponse

@typing.final
class ActionRunConfigSetRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRunConfig:
        """ActionRunConfig carries the value to set into the datastore.
        See the documentation on the ActionRunConfig struct for which fields are required.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRunConfig | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["value", b"value"]) -> None: ...

global___ActionRunConfigSetRequest = ActionRunConfigSetRequest

@typing.final
class ActionRunConfigSetResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def value(self) -> arista.action.v1.action_pb2.ActionRunConfig:
        """Value carries all the values given in the ActionRunConfigSetRequest as well
        as any server-generated values.
        """

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp at which the system recognizes the
        creation. The only guarantees made about this timestamp are:

           - it is after the time the request was received
           - a time-ranged query with StartTime==CreatedAt will include this instance.
        """

    def __init__(
        self,
        *,
        value: arista.action.v1.action_pb2.ActionRunConfig | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["time", b"time", "value", b"value"]) -> None: ...

global___ActionRunConfigSetResponse = ActionRunConfigSetResponse

@typing.final
class ActionRunConfigSetSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUES_FIELD_NUMBER: builtins.int
    @property
    def values(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRunConfig]:
        """value contains a list of ActionRunConfig values to write.
        It is possible to provide more values than can fit within either:
            - the maxiumum send size of the client
            - the maximum receive size of the server
        If this error occurs you must reduce the number of values sent.
        See gRPC "maximum message size" documentation for more information.
        """

    def __init__(
        self,
        *,
        values: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRunConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["values", b"values"]) -> None: ...

global___ActionRunConfigSetSomeRequest = ActionRunConfigSetSomeRequest

@typing.final
class ActionRunConfigSetSomeResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey: ...
    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key"]) -> None: ...

global___ActionRunConfigSetSomeResponse = ActionRunConfigSetSomeResponse

@typing.final
class ActionRunConfigDeleteRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey:
        """Key indicates which ActionRunConfig instance to remove.
        This field must always be set.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key"]) -> None: ...

global___ActionRunConfigDeleteRequest = ActionRunConfigDeleteRequest

@typing.final
class ActionRunConfigDeleteResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey:
        """Key echoes back the key of the deleted ActionRunConfig instance."""

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp at which the system recognizes the
        deletion. The only guarantees made about this timestamp are:

           - it is after the time the request was received
           - a time-ranged query with StartTime==DeletedAt will not include this instance.
        """

    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["key", b"key", "time", b"time"]) -> None: ...

global___ActionRunConfigDeleteResponse = ActionRunConfigDeleteResponse

@typing.final
class ActionRunConfigDeleteSomeRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEYS_FIELD_NUMBER: builtins.int
    @property
    def keys(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRunKey]:
        """key contains a list of ActionRunConfig keys to delete"""

    def __init__(
        self,
        *,
        keys: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRunKey] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["keys", b"keys"]) -> None: ...

global___ActionRunConfigDeleteSomeRequest = ActionRunConfigDeleteSomeRequest

@typing.final
class ActionRunConfigDeleteSomeResponse(google.protobuf.message.Message):
    """ActionRunConfigDeleteSomeResponse is only sent when there is an error."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KEY_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    error: builtins.str
    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey: ...
    def __init__(
        self,
        *,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
        error: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["key", b"key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key"]) -> None: ...

global___ActionRunConfigDeleteSomeResponse = ActionRunConfigDeleteSomeResponse

@typing.final
class ActionRunConfigDeleteAllRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARTIAL_EQ_FILTER_FIELD_NUMBER: builtins.int
    @property
    def partial_eq_filter(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[arista.action.v1.action_pb2.ActionRunConfig]:
        """PartialEqFilter provides a way to server-side filter a DeleteAll.
        This requires all provided fields to be equal to the response.
        A filtered DeleteAll will use GetAll with filter to find things to delete.
        """

    def __init__(
        self,
        *,
        partial_eq_filter: collections.abc.Iterable[arista.action.v1.action_pb2.ActionRunConfig] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["partial_eq_filter", b"partial_eq_filter"]) -> None: ...

global___ActionRunConfigDeleteAllRequest = ActionRunConfigDeleteAllRequest

@typing.final
class ActionRunConfigDeleteAllResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    KEY_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    type: fmp.deletes_pb2.DeleteError.ValueType
    """This describes the class of delete error.
    A DeleteAllResponse is only sent when there is an error.
    """
    @property
    def error(self) -> google.protobuf.wrappers_pb2.StringValue:
        """This indicates the error message from the delete failure."""

    @property
    def key(self) -> arista.action.v1.action_pb2.ActionRunKey:
        """This is the key of the ActionRunConfig instance that failed to be deleted."""

    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time indicates the (UTC) timestamp when the key was being deleted."""

    def __init__(
        self,
        *,
        type: fmp.deletes_pb2.DeleteError.ValueType = ...,
        error: google.protobuf.wrappers_pb2.StringValue | None = ...,
        key: arista.action.v1.action_pb2.ActionRunKey | None = ...,
        time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["error", b"error", "key", b"key", "time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["error", b"error", "key", b"key", "time", b"time", "type", b"type"]) -> None: ...

global___ActionRunConfigDeleteAllResponse = ActionRunConfigDeleteAllResponse
